%global version_major 1
%global version_minor 2
%global version_micro 31
%global meadalpha %{nil}
%global meadrel %{nil}
%global commitid fcb9687bcd3da3bcf376b7d6c064a58710ee4ef7
%global serial 17

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

#no jars in this native build, so skip signing
%define _jarsign_opts --nocopy

%if 0%{?rhel} <= 7
# scldir points to the root dir of the jbcs collection
%define scldir /opt/rh/jbcs-httpd24/root
%endif

%{?scl:%global nfsmountable 1}
%{?scl:%scl_package tomcat-native}
%{!?scl:%global pkg_name %{name}}

%define _with_zips 1
# If you want to build the zips,
# give rpmbuild option '--with zips'

%define with_zips %{?_with_zips:1}%{!?_with_zips:0}
%define without_zips %{!?_with_zips:1}%{?_with_zips:0}

%define packdname %{pkg_name}-%{version}-src

Name:           %{?scl_prefix}tomcat-native
Version:        %{version_major}.%{version_minor}.%{version_micro}
Release:        %{serial}.redhat_%{serial}%{?dist}
Summary:        Tomcat native library

Group:          System Environment/Libraries
License:        ASL 2.0
URL:            http://tomcat.apache.org/tomcat-6.0-doc/apr.html

Source0:        %{pkg_name}-%{commitid}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if "%{?rhel}" == "7"
# 64 bit only natives on RHEL 7
ExcludeArch:   i686 i386
%endif

%if 0%{?rhel} >= 7
BuildRequires:  java-devel
%else
BuildRequires:  java7-devel
%endif

%if 0%{?rhel} > 7
BuildRequires:  python3
BuildRequires:  apr, apr-devel
BuildRequires:  openssl, openssl-devel
%else
BuildRequires:  jbcs-httpd24-apr, jbcs-httpd24-apr-devel
BuildRequires:  jbcs-httpd24-openssl, jbcs-httpd24-openssl-devel, jbcs-httpd24-openssl-libs
%endif
BuildRequires:  jpackage-utils
BuildRequires:  zip
BuildRequires:  autoconf
BuildRequires:  gcc-c++

%if 0%{?rhel} > 7
Requires:       apr
Requires:       openssl
%else
Requires:       jbcs-httpd24-apr
Requires:       jbcs-httpd24-openssl
%endif
Requires(pre):  shadow-utils

%{?scl:Requires: %scl_runtime}

%global __requires_exclude libapr.*
%{?filter_setup:
%filter_from_requires /libapr.*/d
%filter_setup
}

# Upstream compatibility:
Provides:       tcnative = %{version}-%{release}

%description
Tomcat can use the Apache Portable Runtime to provide superior
scalability, performance, and better integration with native server
technologies.  The Apache Portable Runtime is a highly portable library
that is at the heart of Apache HTTP Server 2.x.  APR has many uses,
including access to advanced IO functionality (such as sendfile, epoll
and OpenSSL), OS level functionality (random number generation, system
status, etc), and native process handling (shared memory, NT pipes and
Unix sockets).  This package contains the Tomcat native library which
provides support for using APR in Tomcat.

%package devel
Group:      Development/Libraries
Summary:    Tomcat native library development kit
Requires:   %{?scl:%scl_prefix}tomcat-native = %{version}-%{release}, pkgconfig

%description devel
This package provides the support files which can be used to
build applications using the Tomcat native library.

%if %{with_zips}
%package src-zip
Summary:     Container for the sources of the Tomcat native library.
Group:       Development

%description src-zip
Container for the sources of the Tomcat native library
%endif

%prep
%setup -q -n %{pkg_name}-%{commitid}

%if %{with_zips}
zip -q -r ../%{packdname}.zip *
%endif

%build
cd native

# Setting LDFLAGS equal to the global_ldflags value so that we
# append new values instead of clobber them.
%{?__global_ldflags:LDFLAGS="%__global_ldflags"}
test -d "%{?scldir}/usr/lib64" && \
LDFLAGS="-L%{?scldir}/usr/lib64 $LDFLAGS" || \
LDFLAGS="-L%{?scldir}/usr/lib $LDFLAGS"
# Export require for rhel-6; rhel-6 handles this in the configure macro
export LDFLAGS
echo %{?scldir}%{_root_libdir}
#export CFLAGS="-fPIC -g -DTCN_RELEASE_VERSION=\"-%{serial}\""
#export CPPFLAGS="-I%{_includedir}"
#export LDFLAGS="-L%{_libdir} -Wl,-rpath=%{_libdir} -Wl,-z,relro,-z,now"
./buildconf --with-apr=%{?scldir}%{_root_libdir}/apr-1
%configure \
    --with-apr=%{?scldir}%{_root_bindir}/apr-1-config \
    --with-ssl=%{?scldir}/usr \
    --with-java-home=%{java_home} \
    --with-java-platform=2
make %{?_smp_mflags} CFLAGS="-fno-strict-aliasing -DTCN_RELEASE_VERSION=\"-%{serial}\""
#make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make -C native install DESTDIR=$RPM_BUILD_ROOT

%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_libdir}/%{pkg_name}
%{__install} -d -m 0755 ${RPM_BUILD_ROOT}%{_includedir}/%{pkg_name}

%ifarch i386 i686
archdir=linux-i686
%endif
%ifarch ppc64
archdir=linux-ppc64
%endif
%ifarch x86_64
archdir=linux-x86_64
%endif

%if %{with_zips}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev
%{__install} ../%{packdname}.zip ${RPM_BUILD_ROOT}%{_javadir}/%{pkg_name}-fordev/
%endif

# Instead of using %%doc, copy files in place manually
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_docdir}/%{pkg_name}-%{version}/
cp LICENSE ${RPM_BUILD_ROOT}%{_docdir}/%{pkg_name}-%{version}/
cp NOTICE ${RPM_BUILD_ROOT}%{_docdir}/%{pkg_name}-%{version}/

# Copy devel items to the approriate place
cp -r native/build ${RPM_BUILD_ROOT}%{_libdir}/%{pkg_name}/
# no includedir is created now: BZ 64260: Clean up install target
# mv ${RPM_BUILD_ROOT}%{_includedir}/*.h ${RPM_BUILD_ROOT}%{_includedir}/%{pkg_name}/

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
# %%doc included the SCL name, which we don't want to do
%{_docdir}/%{pkg_name}-%{version}/LICENSE
%{_docdir}/%{pkg_name}-%{version}/NOTICE
# Note: unversioned *.so needed here due to how Tomcat loads the lib :(
%{_libdir}/libtcnative*.so*
%{_docdir}/%{pkg_name}-%{version}

%files devel
%defattr(-,root,root,-)
%{_libdir}/libtcnative*.*a
# BZ 64260: Clean up install target
# %%{_libdir}/pkgconfig
%{_includedir}/%{pkg_name}
%{_libdir}/%{pkg_name}/build

%if %{with_zips}
%files src-zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{pkg_name}-fordev
%{_javadir}/%{pkg_name}-fordev/%{packdname}.zip
%endif

%changelog
* Tue Feb 13 2024 Sokratis Zappis <szappis@redhat.com> - 1.2.31-17.redhat_17
- Build for 5.7.8 to consume latest openssl from JBCS
- Resolves: [JWS-3138] - CVE-2023-5678

* Wed Nov 15 2023 Sokratis Zappis <szappis@redhat.com> - 1.2.31-16.redhat_16
- Build for 5.7.7.CR1 to consume latest openssl from JBCS

* Mon Aug 28 2023 Sokratis Zappis <szappis@redhat.com> - 1.2.31-15.redhat_15
- Build for 5.7.4 to consume latest apr from JBCS
- Resolves: JWS-3053 - CVE-2022-24963 apr: integer overflow/wraparound in apr_encode

* Fri May 19 2023 Sokratis Zappis <szappis@redhat.com> - 1.2.31-14.redhat_14
- Build for 5.7.3 to consume latest openssl from JBCS

* Tue Mar 07 2023 Sokratis Zappis <szappis@redhat.com> - 1.2.31-13.redhat_13
- Build for 5.7.2.CR1

* Wed Nov 09 2022 Sokratis Zappis <szappis@redhat.com> - 1.2.31-11.redhat_11
- Build for 5.7.1

* Fri Oct 07 2022 Sokratis Zappis <szappis@redhat.com> - 1.2.31-10.redhat_10
- Rebuild to consume latest openssl from JBCS

* Mon Jun 27 2022 Sokratis Zappis <szappis@redhat.com> - 1.2.31-9.redhat_9
- Rebuild to consume latest openssl from JBCS

* Mon Apr 25 2022 Hui Wang <huwang@redhat.com> - 1.2.31-5.redhat_5
- Revert the change for LDFLAGS

* Wed Mar 30 2022 Hui Wang <huwang@redhat.com> - 1.2.31-4.redhat_4
- Rebuild with the latest apr and openssl

* Mon Mar 28 2022 Hui Wang <huwang@redhat.com> - 1.2.31-3.redhat_3
- Rebuild

* Fri Mar 25 2022 Hui Wang <huwang@redhat.com> - 1.2.31-2.redhat_2
- Rebuild with the latest apr and openssl

* Mon Mar 07 2022 Hui Wang <huwang@redhat.com> - 1.2.31-1.redhat_1
- Update to 1.2.31

* Thu Aug 05 2021 Coty Sutherland <csutherl@redhat.com> - 1.2.30-2.redhat_2
- Add fix for OpenSSL 3.0 build

* Tue Jul 27 2021 Sokratis Zappis <szappis@redhat.com> - 1.2.30-1.redhat_1
- JWS-1609 Upgrade tomcat-native to 1.2.30

* Tue Sep 15 2020 Coty Sutherland <csutherl@redhat.com> - 1.2.25-1.redhat_1
- JWS-1631 Upgrade tomcat-native to 1.2.25

* Tue Jun 23 2020 Hui Wang <huwang@redhat.com> - 1.2.24-2.redhat_2
- JWS-1631 Upgrade tomcat-native to 1.2.24
- Comment includedir and pkgconfig related commands out because of BZ 64260: Clean up install target

* Mon Jan 27 2020 Coty Sutherland <csutherl@redhat.com> - 1.2.23-3.redhat_3
- JWS-1465 Rebase tomcat-native to 1.2.23

* Mon Aug 26 2019 George Zaronikas <gzaronik@redhat.com> - 1.2.21-33.redhat_1
- Bumping lookaside commit

* Thu Aug 08 2019 Yaakov Selkowitz <yselkowi@redhat.com> - 1.2.21-30.redhat_1
- Rebuilt for multiple architectures

* Fri Jan 25 2019 Coty Sutherland <csutherl@redhat.com> - 1.2.17-27.redhat_1
- Resolves: JWS-1307 Use APR and OpenSSL from RHEL instead of JBCS

* Fri Nov 16 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.17-23.redhat_1
- Resolves: JWS-1140 tomcat-native memory leak when using Mutual authentication + OCSP

* Tue Oct 30 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.17-22.redhat_1
- Resolves: JWS-1054 missing nfsmountable directive
- Resolves: JWS-743 Add devel package

* Fri Oct 12 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.17-21.redhat_1
- Build with python3

* Thu May 10 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.17-1.redhat_1
- Rebase to 1.2.17

* Thu May 10 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.16-2.redhat_2
- Resolves: JWS-727 Removing tomcat doesn't remove a few directories

* Mon Feb 19 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.16-1.redhat_1
- Rebase to 1.2.16

* Mon Jul 17 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.12-2.redhat_2
- Resolves: JWS-637 tomcat-native openssl dependency might be too general

* Fri Jun 23 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.12-1.redhat_1
- Rebase to 1.2.12

* Mon Feb 27 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-8.redhat_8
- Resolves: JWS-657 tomcat-native installs RHEL apr in addition to jbcs-httpd24-httpd-libs

* Thu Feb 02 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-7.redhat_7
- Resolves: JWS-616 tomcat-native uses the wrong APR library

* Fri Sep 09 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.8-6.redhat_6
- Adjusting BuildRequires after JBCS-150 was fixed

* Fri Jul 08 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.8-1.redhat_1
- Building 1.2.8 as JWS 3.1 candidate

* Wed Jun 01 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.6-2.redhat_1
- Update LDFLAGS setting to include %__global_ldflags value instead of ignoring the previous value
- Add export of LDFLAGS to fix rhel-6 builds

* Thu Apr 21 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.6-1.redhat_1
- Building 1.2.6 as JWS 3.1 candidate
